// on start and stop use the 2 buffers to sync.  KILL the processing thread on stop
// on start copy in the worldCopy to world and start processing again

// ramdom read crashes on error, when going fast

// color option

// (x + 1) * zoom

#include <Application.h>
#include <CheckBox.h>
#include <Window.h>
#include <View.h>
#include <map.h>
#include <OS.h>
#include <Button.h>
#include <Beep.h>
#include "life.h"
#include <Slider.h>
#include <Screen.h>

#define SET_ZOOM_LEVEL 'szlv'
#define START_GAME 'stgm'
#define SET_GRID 'stgd'
#define PAUSE_GAME 'psgm'
sem_id life_sem;
sem_id compute_sem;

int32 lifeWork(void * incomming);
std::map<LPoint, cell> world;

bool LPoint::operator< (const LPoint a) const  ///////////VERY IMPORTANT> SO VERY IMPORTANT< FIX ME!!!!!!!!!!
{	return (a.y * 10000 + a.x) < (y * 10000 + x);	}

LPoint::LPoint() : BPoint(){}
LPoint::LPoint(float X, float Y) : BPoint(X,Y){}
LPoint::LPoint(const LPoint& pt) : BPoint(pt) {}
LPoint::LPoint(const BPoint& pt) : BPoint(pt) {}

cell::cell()			{	alive = false;	aliveNs = 0;	}
void cell::increment()	{	++aliveNs;	}
void cell::makeAlive()	{	alive = true;  cout << "MAKING ALIVE" << endl;}

//?? I guess teh constructor should have it
LWindow::LWindow(BRect rect, char * name, window_type f, long int s) :	BWindow(rect, name, f, s)
{	int test = 0;
	tid = spawn_thread(lifeWork, 
					"life work", 
					10, (void *)test );
}
LView::LView(BRect frame, char* name) : BView(frame, name, B_FOLLOW_LEFT_RIGHT | B_FOLLOW_TOP_BOTTOM, B_WILL_DRAW)
{	zoom = 30; grid = true; }

void LWindow::MessageReceived(BMessage * message)
{		
	switch (message->what)
	{
		case START_GAME:
			resume_thread( tid);
			((dotterApp *)be_app)->StartButtonOn(true);
			break;	
		case PAUSE_GAME:
			acquire_sem(compute_sem);
			suspend_thread( tid);
			release_sem(compute_sem);
			((dotterApp *)be_app)->StartButtonOn(false);
			break;
		case SET_ZOOM_LEVEL:
			((dotterApp *)be_app)->SetZoom();
			break;
		case SET_GRID:
			((dotterApp *)be_app)->SetGrid();
			break;
		default:
			BWindow::MessageReceived(message);
			break;
	}	
}

//  look at this stuff, should we clean it?
void LView::SetZoom(int a) { Window()->Lock(); zoom = a; Invalidate(); Window()->Unlock();}
void LView::SetGrid(bool a){ Window()->Lock(); grid = a; Invalidate(); Window()->Unlock();}
int  LView::GetZoom()	   {	return zoom; }
bool LView::GetGrid()	   {	return grid; }
void dotterApp::SetZoom()  {	lifeView->SetZoom(zoomSlider->Value());		}
void dotterApp::SetGrid()  {	lifeView->SetGrid(gridCheckbox->Value());	}
/////////////////////

void dotterApp::StartButtonOn(bool isOn)
{
	if (isOn)
	{
		startButton->SetLabel("stop");
		startButton->SetMessage(new	BMessage(PAUSE_GAME));
	}
	else
	{
		startButton->SetLabel("start");
		startButton->SetMessage(new BMessage(START_GAME));
	}
}
	

void LView::MouseDown(BPoint point)
{	
	uint32 buttons = 0;
	acquire_sem(compute_sem);// pauses the game 
	GetMouse(&point, &buttons, true);
	while (buttons == B_PRIMARY_MOUSE_BUTTON)
	{	
		GetMouse(&point, &buttons, true);
		point.x = (int (point.x-1)/zoom);
		point.y = (int (point.y-1)/zoom);
		world[point].makeAlive();
		worldCopy[point].makeAlive();
		Window()->Lock();
		Draw(BRect(point.x * zoom, point.y * zoom, (point.x +1) * zoom, (point.y + 1) * zoom));
		Window()->Unlock();
		snooze(10000);
	}
	if (buttons == B_SECONDARY_MOUSE_BUTTON)
	{
		GetMouse(&point, &buttons, true);
		point.x = (int (point.x-1)/zoom);
		point.y = (int (point.y-1)/zoom);
		world.erase(point);
		worldCopy.erase(point);
		Window()->Lock();
		Invalidate(BRect(point.x * zoom, point.y * zoom, (point.x +1) * zoom, (point.y + 1) * zoom));
		Window()->Unlock();
	}
	release_sem(compute_sem);
}

// This needs to be sped up
void LView::Draw(BRect rect)  // there is a drawBmp that works on an area
{
	float x, y;	
	rgb_color gridColor = {100,100,100};

	//BScreen screen;
	//screen.WaitForRetrace();?? doesn't seem to help
	
	if (grid)  // only draws what is required in the rect that was invalidated
	{
		BPoint LeftTop, RightBottom;
		LeftTop = rect.LeftTop();
		rect.PrintToStream();
		RightBottom = rect.RightBottom();
		BeginLineArray(rect.IntegerWidth() / zoom + rect.IntegerHeight() / zoom + 4);// upper limit, best below 256
 		
 		int i;
 		for (i = (int) LeftTop.x - (int (LeftTop.x) % zoom); i <= RightBottom.x ; i += zoom ) // area of the brect
		{
			AddLine(BPoint(i, LeftTop.y), BPoint(i, RightBottom.y), gridColor);
		}
		for (i = (int) LeftTop.y - (int (LeftTop.y) % zoom) ; i <= RightBottom.y ; i += zoom )
		{							//(Horizontal)
			AddLine(BPoint(LeftTop.x, i), BPoint(RightBottom.x, i), gridColor); 
		}
		EndLineArray();
	}
	std::map<LPoint, cell>::iterator pos;
	acquire_sem(life_sem); 
	for (pos = worldCopy.begin(); pos != worldCopy.end(); ++pos)
	{
		x = pos->first.x;
		y = pos->first.y;
		if (grid)
			FillRect(BRect(x*zoom+1,y*zoom+1,x*zoom+zoom-1,y*zoom+zoom-1), B_SOLID_HIGH); // don't fill in
		else
			FillRect(BRect(x*zoom,y*zoom,x*zoom+zoom,y*zoom+zoom), B_SOLID_HIGH);		  // make grid overlap
	}
	release_sem(life_sem);
}

dotterApp::dotterApp() : BApplication("application/x-vnd.detroitpunk-life")
{	
	if ((life_sem = create_sem(1, "life block copy")) < B_OK)
		be_app->Quit();
	if ((compute_sem = create_sem(1, "life computing")) < B_OK)
		be_app->Quit();
	rgb_color grey = {216,216,216};
	rgb_color blue = {102, 102, 203};
	blue.red = 102;
	rgb_color green = {102, 203, 102};
	frame = BRect(30,30,300,240);
	BRect lifeViewFrame = lifeWindow->Bounds();
	lifeViewFrame.SetRightBottom(BPoint(frame.RightBottom().x - 44, frame.RightBottom().y - 44) );
	
	lifeWindow = new LWindow(frame, "Life", B_TITLED_WINDOW , B_NOT_ZOOMABLE | B_QUIT_ON_WINDOW_CLOSE);
	lifeView   = new LView(lifeViewFrame, "lifeView");
	lifeScroller = new BScrollView("Big Billay", lifeView, B_FOLLOW_ALL_SIDES, 0, true, true);
	lifeWindow->AddChild(lifeScroller);
	
	controlWindow = new LWindow(BRect(400,30,600,170), "Controls", B_FLOATING_WINDOW, B_NOT_RESIZABLE | B_NOT_ZOOMABLE);
	controlView   = new BView(controlWindow->Bounds(), "controlView", B_FOLLOW_LEFT_RIGHT | B_FOLLOW_TOP_BOTTOM, B_WILL_DRAW);
	
	startButton = new BButton(BRect(10,10,60,30), "start", "start", new BMessage(START_GAME));
	controlWindow->AddChild(startButton);
	
	zoomSlider = new BSlider(BRect(10,40,200,60), "zoom", "Zoom Level", new BMessage(SET_ZOOM_LEVEL), 2, 50);
	zoomSlider->SetValue(lifeView->GetZoom());
	
	gridCheckbox = new BCheckBox(BRect(90,20,150,50), "grid", "Grid", new BMessage(SET_GRID));
	gridCheckbox->SetValue(lifeView->GetGrid());
	
	controlWindow->AddChild(gridCheckbox);
	controlWindow->AddChild(zoomSlider);
	controlWindow->AddChild(controlView);
	
	lifeView->SetHighColor(green);
	lifeView->SetViewColor(170,170,170,0);
	controlView->SetHighColor(green);
	controlView->SetViewColor(grey);
	gridCheckbox->SetViewColor(grey);
	zoomSlider->SetViewColor(grey);
}

void dotterApp::ReadyToRun()
{
	lifeWindow->Show();
	controlWindow->Show();
}


/// THIS SHOULD BECOME DOUBLE BUFFERED
int32 lifeWork(void * incomming) // should we put a beTimer here?
								 //  Pause just calls the sem and waits for work to finish
{
	int xConst = 10000;// constraints ///////////IMPORTANT< MOVE ME SOMEWHARE GOOD
	int yConst = 10000;
	std::map<LPoint, cell>::iterator pos;
	float y, x;
	
	((dotterApp *)be_app)->display(world);

	while (true)
	{	//  increment neighbors (is neighbor alive?)
		acquire_sem(compute_sem);
		for (pos = world.begin(); pos != world.end(); ++pos)  // this takes up more space, but is quicker, max 4 cmps
		{		
			x = pos->first.x;
			y = pos->first.y;
			if (pos->second.alive)
			{
				if  (y == 0) // top
 				{
 					if (x == xConst)  // and right
					{	//set all left and lower points (3)
						world[BPoint(x-1, y)].increment();	// left
						world[BPoint(x, y + 1)].increment();	// bottom
						world[BPoint(x-1, y + 1)].increment();// bottom left
					}
					else if (x == 0) // top and left
					{	//set all right and lower points (3)
						world[BPoint(x+1, y)].increment();	// right
						world[BPoint(x, y + 1)].increment();	// bottom
						world[BPoint(x +1, y + 1)].increment();// bottom right
					}
					else 
					{	//set all lower points
						world[BPoint(x-1, y)].increment();	// left
						world[BPoint(x+1, y)].increment();	// right
						world[BPoint(x, y + 1)].increment();	// bottom
						world[BPoint(x-1, y + 1)].increment();// bottom left
						world[BPoint(x +1, y + 1)].increment();// bottom right
					}
				}
				else if (y == yConst) // bottom
				{
					if (x == xConst)  // and right
					{	//set all left and upper points (3)
						world[BPoint(x-1, y)].increment();	// left	
						world[BPoint(x, y - 1)].increment();	// top
						world[BPoint(x-1, y - 1)].increment();// top left
					}
					else if (x == 0) // bottom and left
					{	//set all right and upper points (3)
						world[BPoint(x+1, y)].increment();	// right
						world[BPoint(x, y - 1)].increment();	// top
						world[BPoint(x+1, y - 1)].increment();// top right
					}
					else  
					{	//set all upper points (5)
						world[BPoint(x-1, y)].increment();	// left
						world[BPoint(x+1, y)].increment();	// right
						world[BPoint(x, y - 1)].increment();	// top
						world[BPoint(x-1, y - 1)].increment();// top left
						world[BPoint(x+1, y - 1)].increment();// top right
					}
				}
				else 
				{
					if (x == xConst) // right (5)
					{	//set all left points
						world[BPoint(x-1, y)].increment();	// left
						world[BPoint(x, y + 1)].increment();	// bottom
						world[BPoint(x-1, y + 1)].increment();// bottom left
						world[BPoint(x, y - 1)].increment();	// top
						world[BPoint(x-1, y - 1)].increment();// top left
					}
					else if (x == 0) // left (5)
					{	//set all right points
						world[BPoint(x+1, y)].increment();	// right
						world[BPoint(x, y + 1)].increment();	// bottom
						world[BPoint(x +1, y + 1)].increment();// bottom right
						world[BPoint(x, y - 1)].increment();	// top
						world[BPoint(x+1, y - 1)].increment();// top right
					}
					else 
					{	//set ALL POINTS (8)
						world[BPoint(x-1, y)].increment();	// left
						world[BPoint(x+1, y)].increment();	// right
						world[BPoint(x, y - 1)].increment();	// top
						world[BPoint(x-1, y - 1)].increment();// top left
						world[BPoint(x+1, y - 1)].increment();// top right
						world[BPoint(x, y + 1)].increment();	// bottom
						world[BPoint(x-1, y + 1)].increment();// bottom left
						world[BPoint(x +1, y + 1)].increment();// bottom right
					}
				}		
			}
		}
		//  we decide who lives and who dies ( and kill the dead )
		for (pos = world.begin(); pos != world.end(); )
		{
			if (pos->second.alive)
			{
				if (pos->second.aliveNs != 2 && pos->second.aliveNs != 3)
				{	
					world.erase(pos++);
				}
				else
				{
				pos->second.aliveNs = 0;
				pos++;
				}
			}
			else
			{
				if (pos->second.aliveNs == 3)
				{
					pos->second.alive = true;
					pos->second.aliveNs = 0;
					pos++;
				}
				else 
				{	
					world.erase(pos++);
				}
			}
		}
		//  display
		((dotterApp *)be_app)->display(world);
		//  optional sleeps
		release_sem(compute_sem);
		snooze(500000);
		//  goto 10
	}
}

/// THIS SHOULD TAKE CARE OF THE DOUBLE BUFFERING
void dotterApp::display(std::map<LPoint, cell> world)
{
	acquire_sem(life_sem); // need to make sure it was not system interupted?? see kernel kit
	lifeView->worldCopy = world;
	release_sem(life_sem);
	
	lifeWindow->Lock();
	lifeView->Invalidate();//////////////////////INVALIDATE WORLD.END-1's grid location for y??
	lifeWindow->Unlock();
}

bool dotterApp::QuitRequested() // need to free memory here
{
	acquire_sem(life_sem); // make it stop working
	be_app->PostMessage(B_QUIT_REQUESTED);
	return true;
}

int main()
{
	new dotterApp;
	be_app->Run();
	delete be_app;
	// crash happens here or later
	return B_OK;
}
